package main

import (
	"fmt"
	"git.swzry.com/zry/YAGTF/yagtf/tfelem"
	"git.swzry.com/zry/YAGTF/yagtf/timefmt"
	"time"
)

func main() {
	test1()
	test2()
}

func test1() {
	tp := timefmt.NewTimePrinter()
	tp.AddPureText("hello")
	tp.AddPureText(",")
	tp.AddPureText(" ")
	tp.AddPureText("gensokyo")
	fmt.Println("Test1", tp.PrintTime(time.Now()))
}

func test2() {
	tp := timefmt.NewTimePrinter()
	tp.AddPureText("\n")
	tp.AddPureText("short_year=")
	tp.AddElement(tfelem.NewYearElement(true))
	tp.AddPureText("\n")
	tp.AddPureText("long_year=")
	tp.AddElement(tfelem.NewYearElement(false))
	tp.AddPureText("\n")
	tp.AddPureText("number_month_nofill=")
	tp.AddElement(tfelem.NewNumbericMonthElement(false))
	tp.AddPureText("\n")
	tp.AddPureText("number_month_fill=")
	tp.AddElement(tfelem.NewNumbericMonthElement(true))
	tp.AddPureText("\n")
	tp.AddPureText("month_name_nofill=")
	tp.AddElement(tfelem.NewEnglishMonthElement(false, false))
	tp.AddPureText("\n")
	tp.AddPureText("month_name_fill=")
	tp.AddElement(tfelem.NewEnglishMonthElement(false, true))
	tp.AddPureText("\n")
	tp.AddPureText("month_name_abbr=")
	tp.AddElement(tfelem.NewEnglishMonthElement(true, false))
	tp.AddPureText("\n")
	tp.AddPureText("day_nofill=")
	tp.AddElement(tfelem.NewDayElement(false))
	tp.AddPureText("\n")
	tp.AddPureText("day_fill=")
	tp.AddElement(tfelem.NewDayElement(true))
	tp.AddPureText("\n")
	tp.AddPureText("24h_nofill=")
	tp.AddElement(tfelem.NewHour24hElement(false))
	tp.AddPureText("\n")
	tp.AddPureText("24h_fill=")
	tp.AddElement(tfelem.NewHour24hElement(true))
	tp.AddPureText("\n")
	tp.AddPureText("12h_nofill=")
	tp.AddElement(tfelem.NewHour12hElement(false))
	tp.AddPureText("\n")
	tp.AddPureText("12h_fill=")
	tp.AddElement(tfelem.NewHour12hElement(true))
	tp.AddPureText("\n")
	tp.AddPureText("millisecond=")
	tp.AddElement(tfelem.NewSecondFloatPartElementWithMilliSec())
	tp.AddPureText("\n")
	tp.AddPureText("microsecond=")
	tp.AddElement(tfelem.NewSecondFloatPartElementWithMicroSec())
	tp.AddPureText("\n")
	tp.AddPureText("nanosecond=")
	tp.AddElement(tfelem.NewSecondFloatPartElementWithNanoSec())
	tp.AddPureText("\n")
	tp.AddPureText("yearday_nofill=")
	tp.AddElement(tfelem.NewYearDayElement(false))
	tp.AddPureText("\n")
	tp.AddPureText("yearday_fill=")
	tp.AddElement(tfelem.NewYearDayElement(true))
	tp.AddPureText("\n")
	tp.AddPureText("week_nofill=")
	tp.AddElement(tfelem.NewWeekElement(false))
	tp.AddPureText("\n")
	tp.AddPureText("week_fill=")
	tp.AddElement(tfelem.NewWeekElement(true))
	tp.AddPureText("\n")
	tp.AddPureText("weekday_english_nofill=")
	tp.AddElement(tfelem.NewEnglishWeekDayElement(false, false))
	tp.AddPureText("\n")
	tp.AddPureText("weekday_english_fill=")
	tp.AddElement(tfelem.NewEnglishWeekDayElement(false, true))
	tp.AddPureText("\n")
	tp.AddPureText("weekday_english_abbr=")
	tp.AddElement(tfelem.NewEnglishWeekDayElement(true, false))
	tp.AddPureText("\n")
	tp.AddPureText("weekday_numberic=")
	tp.AddElement(tfelem.NewNumbericWeekDayElement())
	tp.AddPureText("\n")
	tp.AddPureText("timezone_abbr=")
	tp.AddElement(tfelem.NewTimeZoneAbbrElement())
	tp.AddPureText("\n")
	tp.AddPureText("timezone_utc_offset=")
	tp.AddElement(tfelem.NewTimeZoneUTCOffsetElement())
	tp.AddPureText("\n")
	tp.AddPureText("timezone_utc_second_nofill=")
	tp.AddElement(tfelem.NewTimeZoneNumbericOffsetElement(false))
	tp.AddPureText("\n")
	tp.AddPureText("timezone_utc_second_fill=")
	tp.AddElement(tfelem.NewTimeZoneNumbericOffsetElement(true))
	tp.AddPureText("\n")
	fmt.Println("Test2-Now", tp.PrintTime(time.Now()))
	t1, _ := time.Parse(time.RFC3339, "2000-02-15T13:02:59+08:00")
	fmt.Println("Test2- 2000-02-15 13:02:59 ", tp.PrintTime(t1))
}
