package timefmt

import (
	"time"
)

type TimeFormatter struct {
	printer *TimePrinter
}

func (this *TimeFormatter) Format(t time.Time) string {
	return this.printer.PrintTime(t)
}

func (this *TimeFormatter) ForceTimezone(tz *time.Location) {
	this.printer.UseTimezone(tz)
}

func (this *TimeFormatter) ForceLocalTimezone() {
	this.printer.UseLocalTimezone()
}

func (this *TimeFormatter) ForceUTC() {
	this.printer.UseUTC()
}

func NewTimeFormatter(fmtstr string) *TimeFormatter {
	tf := &TimeFormatter{
		printer: NewTimePrinter(),
	}
	ParseFormatString(tf.printer, fmtstr)
	return tf
}
